(function() {
	if(window.RbJSBridge) {
		return;
	};

	var _readyMessageIframe,
		_readyMessageIframeId = '_RbJSBridgeIframe',
		_sendMessageQueue = [],
		_callback_count = 1000,
		_callback_map = {},
		_event_hook_map = {},
		_setResultIframe,
		_setResultQueueRunning = false,
		_setResultQueue = [],
		_setResultIframeId = '_RbJSBridge_SetResult',
		_CUSTOM_PROTOCOL_SCHEME = 'rubik',
		_MESSAGE_TYPE = '__msg_type',
		_CALLBACK_ID = '__callback_id',
		_EVENT_ID = '__event_id',
		_QUEUE_HAS_MESSAGE = 'dispatch_message/',
		_QUEUE_SET_RESULT = 'private/setresult/';

	var _handleMessageIdentifier = _handleMessageFromApp;
	var _fetchQueueIdentifier = _fetchQueue;
	var _callIdentifier = _call;

	function _on(event, callback) {
		if(!event || typeof event !== 'string') {
			return;
		};

		if(typeof callback !== 'function') {
			return;
		};

		_event_hook_map[event] = callback;
	}

     // UTF8
        var UTF8 = {

            // public method for url encoding
            encode: function(string) {
                string = string.replace(/\r\n/g, "\n");
                var utftext = "";

                for (var n = 0; n < string.length; n++) {

                    var c = string.charCodeAt(n);

                    if (c < 128) {
                        utftext += String.fromCharCode(c);
                    } else if ((c > 127) && (c < 2048)) {
                        utftext += String.fromCharCode((c >> 6) | 192);
                        utftext += String.fromCharCode((c & 63) | 128);
                    } else {
                        utftext += String.fromCharCode((c >> 12) | 224);
                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }

                }

                return utftext;
            },

            // public method for url decoding
            decode: function(utftext) {
                var string = "";
                var i = 0;
                var c = c1 = c2 = 0;

                while (i < utftext.length) {

                    c = utftext.charCodeAt(i);

                    if (c < 128) {
                        string += String.fromCharCode(c);
                        i++;
                    } else if ((c > 191) && (c < 224)) {
                        c2 = utftext.charCodeAt(i + 1);
                        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                        i += 2;
                    } else {
                        c2 = utftext.charCodeAt(i + 1);
                        c3 = utftext.charCodeAt(i + 2);
                        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                        i += 3;
                    }

                }

                return string;
            }

        };

	var base64encodechars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	function base64encode(str) {
		if(str === undefined) {
			return str;
		}

		var out, i, len;
		var c1, c2, c3;
		len = str.length;
		i = 0;
		out = "";
		while(i < len) {
			c1 = str.charCodeAt(i++) & 0xff;
			if(i == len) {
				out += base64encodechars.charAt(c1 >> 2);
				out += base64encodechars.charAt((c1 & 0x3) << 4);
				out += "==";
				break;
			}
			c2 = str.charCodeAt(i++);
			if(i == len) {
				out += base64encodechars.charAt(c1 >> 2);
				out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
				out += base64encodechars.charAt((c2 & 0xf) << 2);
				out += "=";
				break;
			}
			c3 = str.charCodeAt(i++);
			out += base64encodechars.charAt(c1 >> 2);
			out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
			out += base64encodechars.charAt(((c2 & 0xf) << 2) | ((c3 & 0xc0) >> 6));
			out += base64encodechars.charAt(c3 & 0x3f);
		}
		return out;
	}

	function _createQueueReadyIframe(doc) {
		_setResultIframe = doc.createElement('iframe');
		_setResultIframe.id = _setResultIframeId;
		_setResultIframe.style.display = 'none';
		console.log(doc.documentElement)
		console.log(doc)
		doc.documentElement.appendChild(_setResultIframe);

		_readyMessageIframe = doc.createElement('iframe');
		_readyMessageIframe.id = _readyMessageIframeId;
		_readyMessageIframe.style.display = 'none';
		doc.documentElement.appendChild(_readyMessageIframe);

		return _readyMessageIframe;
	};

	function _call(func, params, callback) {
		var curFuncIdentifier = RbJSBridge.call;
		if(curFuncIdentifier !== _callIdentifier) {
			return;
		}
		if(!func || typeof func !== 'string') {
			return;
		};
		if(typeof params !== 'object') {
			params = {};
		};

		var callbackID = (_callback_count++).toString();

		if(typeof callback === 'function') {
			_callback_map[callbackID] = callback;
		};

		var msgObj = {
			'func': func,
			'params': params
		};
		msgObj[_MESSAGE_TYPE] = 'call';
		msgObj[_CALLBACK_ID] = callbackID;

		_sendMessage(JSON.stringify(msgObj));
	};

	function _sendMessage(message) {
		_sendMessageQueue.push(message);
		if(_readyMessageIframe) {
			if(window.RbJSBridge._isBridgeByIframe) {
				_readyMessageIframe.src = _CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_HAS_MESSAGE;
			} else {
				console.log(_CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_HAS_MESSAGE);
			}
		}
	};

	function _fetchQueue() {
		var curFuncIdentifier = RbJSBridge._fetchQueue;
		if(curFuncIdentifier !== _fetchQueueIdentifier) {
			return '';
		}
		var messageQueueString = JSON.stringify(_sendMessageQueue);
		_sendMessageQueue = [];

		_setResultValue('SCENE_FETCHQUEUE', messageQueueString);
		return messageQueueString;
	};

	function _setResultValue(scene, result) {
		if(result === undefined) {
			result = 'dummy';
		}
		_setResultQueue.push(scene + '&' + base64encode(UTF8.encode(result)));
		if(!_setResultQueueRunning) {
			_continueSetResult();
		}
	}

	function _continueSetResult() {
		var result = _setResultQueue.shift();
		if(result === undefined) {
			_setResultQueueRunning = false;
		} else {
			if(window.RbJSBridge._isBridgeByIframe) {
				_setResultQueueRunning = true;
				_setResultIframe.src = _CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_SET_RESULT + result;
			} else {
				_setResultQueueRunning = true;
				console.log(_CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_SET_RESULT + result);
			}
		}
	}

	function _handleMessageFromApp(message) {
		var curFuncIdentifier = RbJSBridge._handleMessageFromApp;
		if(curFuncIdentifier !== _handleMessageIdentifier) {
			return '{}';
		}
		var ret;
		var msgWrap;
		msgWrap = message;

		switch(msgWrap[_MESSAGE_TYPE]) {
			case 'callback':
				{
					if(typeof msgWrap[_CALLBACK_ID] === 'string' && typeof _callback_map[msgWrap[_CALLBACK_ID]] === 'function') {
						var ret = _callback_map[msgWrap[_CALLBACK_ID]](msgWrap['__params']);
						delete _callback_map[msgWrap[_CALLBACK_ID]]; // can only call once
						//window.JsApi && JsApi.keep_setReturnValue && window.JsApi.keep_setReturnValue('SCENE_HANDLEMSGFROMWX', JSON.stringify(ret));
						_setResultValue('SCENE_HANDLEMSGFROMWX', JSON.stringify(ret));
						return JSON.stringify(ret);
					}
					//window.JsApi && JsApi.keep_setReturnValue && window.JsApi.keep_setReturnValue('SCENE_HANDLEMSGFROMWX', JSON.stringify({'__err_code':'cb404'}));
					_setResultValue('SCENE_HANDLEMSGFROMWX', JSON.stringify({
						'__err_code': 'cb404'
					}));
					return JSON.stringify({
						'__err_code': 'cb404'
					});
				}
				break;
			case 'event':
				{
					if(typeof msgWrap[_EVENT_ID] === 'string') {
						if(typeof _event_hook_map[msgWrap[_EVENT_ID]] === 'function') {
							//window.JsApi && JsApi.keep_setReturnValue && window.JsApi.keep_setReturnValue('SCENE_HANDLEMSGFROMWX', JSON.stringify(ret));                                                                                                                                    
							var ret = _event_hook_map[msgWrap[_EVENT_ID]](msgWrap['__params']);
							_setResultValue('SCENE_HANDLEMSGFROMWX', JSON.stringify(ret));
							return JSON.stringify(ret);
						}

					}
					//window.JsApi && JsApi.keep_setReturnValue && window.JsApi.keep_setReturnValue('SCENE_HANDLEMSGFROMWX', JSON.stringify({'__err_code':'ev404'}));
					_setResultValue('SCENE_HANDLEMSGFROMWX', JSON.stringify({
						'__err_code': 'ev404'
					}));
					return JSON.stringify({
						'__err_code': 'ev404'
					});
				}
				break;
		}
	};

	function _setDefaultEventHandlers() {
	    // the first event
        _on('sys:init',function(ses){
            // 避免由于Java层多次发起init请求，造成网页端多次收到WeixinJSBridgeReady事件
            if (window.RbJSBridge._hasInit && window.__rbkjs_is_injected_success) {
                console.log('hasInit, no need to init again');
                return;
            }else{
                console.log('init RbJSBridge');
            }

            window.RbJSBridge._hasInit = true;

            // bridge ready
            var readyEvent = doc.createEvent('Events');
            readyEvent.initEvent('RbJSBridge');
            doc.dispatchEvent(readyEvent);
        });
	}
	
	var _RbJSBridge = {
		call: _call,
		_fetchQueue: _fetchQueue,
		_hasInit: false,
		_hasPreInit: false,
		_isBridgeByIframe: true,
		_event_hook_map:_event_hook_map,
		on: _on,
		_continueSetResult: _continueSetResult
	};

	try{
         Object.defineProperty(_RbJSBridge, '_handleMessageFromApp', {
            value:_handleMessageFromApp,
            writable:false,
            configurable: false
         });
    }catch(e){
         return
    }

	Object.defineProperty(window, 'RbJSBridge', {
		value: _RbJSBridge,
		writeable: false
	});

	var doc = document;
	_createQueueReadyIframe(doc);
	_setDefaultEventHandlers();
})();